      subroutine plb4qcd(imode,isel)
      implicit none

      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

      INTEGER MXDIM,NDMX,NDIM,NWILD,IG,NCALL,ITMX1,ITMX2
      DOUBLE PRECISION XL,XU,ACC1,ACC2
      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2

      INTEGER JPROC
      COMMON /AMJPRC/JPROC

      CHARACTER GRCPROC*40
      COMMON/GRCCHAR/GRCPROC

      INTEGER i,imode,isel
      DOUBLE PRECISION  xsn(10),rna,grcsigsum,ransum
      INTEGER imrg,ijrg,idummy

      DOUBLE PRECISION drn
      EXTERNAL drn

C...Decide subprocess ID.
      if (imode.eq.1) then
         ijrg = 404
         imrg = 2
         xsn(2) = 0.8d0
         rna = xrun(11)
         xsn(1) = 0.0d0
         xsn(imrg+1) = 1.0d0
         do i = 1,imrg
            if (rna.gt.xsn(i).and.rna.le.xsn(i+1)) then
               gpri(10) = (rna-xsn(i))/(xsn(i+1)-xsn(i))
               yacob = yacob/(xsn(i+1)-xsn(i))
               jproc = i + ijrg
            endif
         enddo

C...Set dimension and process character.
      else if (imode.eq.2) then
         if (isel.eq.162) then
            ndim = 11
            grcproc = 'pp(bar) -> bbbb'
         endif
         if (isel.eq.405) then
            ndim = 10
            grcproc = 'gg -> bbbb (QCD4)'
         endif
         if (isel.eq.406) then
            ndim = 11
            grcproc = 'qq -> bbbb (QCD4)'
         endif

C...Initialize kinematic parameter.
      else if (imode.eq.3) then

         if (jproc.eq.162) then
            mxreg = 2
            ktype = 6
            cxtype = 5
            gtau(1) = 1
            gtau(14) = 5
            gyst(1) = 1
            gyst(14) = 5
            gcos3(1) = 1
            gcos3(14) = 4
            gq12(1) = 1
            gq12(14) = 2
            gq22(1) = 1
            gq22(14) = 2
            gspr(1) = 2
            geps(1) = 5.0d-1
            gspr(2) = 2
            geps(2) = 5.0d-1
         endif
         
         if (jproc.eq.405) then
            mxreg = 2
            ktype = 6
            cxtype = 5
            gtau(1) = 1
            gtau(14) = 5
            gyst(1) = 1
            gyst(14) = 5
            gcos3(1) = 1
            gcos3(14) = 4
            gq12(1) = 1
            gq12(14) = 2
            gq22(1) = 1
            gq22(14) = 2
            gspr(1) = 2
            geps(1) = 5.0d-1
            gspr(2) = 2
            geps(2) = 5.0d-1
         endif

         if (jproc.eq.406) then
            mxreg = 2
            ktype = 6
            cxtype = 5
            gtau(1) = 1
            gtau(14) = 5
            gyst(1) = 1
            gyst(14) = 1
            gcos3(1) = 1
            gcos3(14) = 4
            gq12(1) = 1
            gq12(14) = 2
            gq22(1) = 1
            gq22(14) = 2
            gspr(1) = 2
            geps(1) = 7.0d-1
            gspr(2) = 2
            geps(2) = 7.0d-1
         endif

C...Set flavor and if necessary, decide weight of each phase space.
      else if (imode.eq.4) then

         if (igsub.eq.162) then
            call grcffil
            grcsigsum = grcdsig(1)+grcdsig(2)
            ransum = drn(idummy)*grcsigsum
            isel = 0
            do while (ransum.gt.0.0d0)
               isel = isel + 1
               ransum = ransum - grcdsig(isel)
            enddo
         endif

         if (igsub.eq.405) then
            call g405finit
            call grcffil
            grcsigsum = grcdsig(1)+grcdsig(2)
            ransum = drn(idummy)*grcsigsum
            isel = 0
            do while (ransum.gt.0.0d0)
               isel = isel + 1
               ransum = ransum - grcdsig(isel)
            enddo
         endif

         if (igsub.eq.406) then
            call g406finit
            call grcffil
            grcsigsum = grcdsig(1)+grcdsig(2)
            ransum = drn(idummy)*grcsigsum
            isel = 0
            do while (ransum.gt.0.0d0)
               isel = isel + 1
               ransum = ransum - grcdsig(isel)
            enddo
         endif
      endif

      return
      end
